/* Programm steckdosen */
/* Schaltet bis zu 16 Steckdosen über den Computer ein und aus. */

/* ACHTUNG! Zum Kompilieren make benutzen. */

/* Hauptprogramm */
/* hauptprg.c */

#include <ncurses.h>  /* Für die Texte an einer bestimmten Bildschirmposition auszugeben. */                        
#include <sys/io.h>   /* Für den Zugriff auf den Druckerport. */
#include "hauptprg.h" /* Enthält die Funktionsdeklarationen. */

#define basisadresse 0x378  /* Basisadresse LPT 1. */
#define PAR_CTRL_EPP 0x20   /* Maske für LPT auf Ausgang zu stellen. */

int main(void)

{
   char taste; /* gedrückte Taste */
   
	 if (ioperm( basisadresse, 3, 1) != 0 ) /* Ist der Druckerport frei ? */
   { 
     perror( "Fehler: Kann den Druckerport nicht zum Schreiben / Lesen freigeben." );
     return(-1);
   } 
   outb(inb(basisadresse+2) & ~PAR_CTRL_EPP, basisadresse+2 ); /* LPT auf AUSGANG stellen */
   outb(0,basisadresse); /* Erst einmal alles aus */ 
   initscr(); /* Start ncurses Modus */
   textvereinbarung (); /* Texte festlegen */
   noecho(); /* Ausgabe der gedrückten Taste abschalten. */
   while(1) /* Endlosschleife */
   {
    textausgabe(&hauptmenue[0]); /* Hauptmenü ausgeben */
    taste = getch(); /* Tastendruck von der Tastatur einlesen. */
    switch (taste)
    {
     case '1':steckdose(1,1,1);     /* Steckdose 1 ein */
              getchar();
              break;
     case '2':steckdose(1,0,1);     /* Steckdose 1 aus */
              getchar();
              break;
     case '3':steckdose(2,1,1);     /* Steckdose 2 ein */
              getchar();
              break;
     case '4':steckdose(2,0,1);     /* Steckdose 2 aus */
              getchar();
              break;
     case '5':steckdose(3,1,1);     /* Steckdose 3 ein */
              getchar();
              break; 
     case '6':steckdose(3,0,1);     /* Steckdose 3 aus */
              getchar();
              break; 
     case '7':steckdose(4,1,1);     /* Steckdose 4 ein */
              getchar();
              break; 
     case '8':steckdose(4,0,1);     /* Steckdose 4 aus */
              getchar();
              break;
     case 'a':steckdose(5,1,1);     /* Steckdose 5 ein */
              getchar();
              break; 
     case 'b':steckdose(5,0,1);     /* Steckdose 5 aus */
              getchar();
              break;
     case 'c':steckdose(6,1,1);     /* Steckdose 6 ein */
              getchar();
              break; 
     case 'd':steckdose(6,0,1);     /* Steckdose 6 aus */
              getchar();
              break;
     case 'e':steckdose(7,1,1);     /* Steckdose 7 ein */
              getchar();
              break; 
     case 'f':steckdose(7,0,1);     /* Steckdose 7 aus */
              getchar();
              break;
     case 'g':steckdose(8,1,1);     /* Steckdose 8 ein */
              getchar();
              break; 
     case 'h':steckdose(8,0,1);     /* Steckdose 8 aus */
              getchar();
              break;
     case 'i':steckdose(9,1,1);     /* Steckdose 9 ein */
              getchar();
              break;
     case 'j':steckdose(9,0,1);     /* Steckdose 9 aus */
              getchar();
              break;
     case 'k':steckdose(10,1,1);    /* Steckdose 10 ein */
              getchar();
              break;
     case 'l':steckdose(10,0,1);    /* Steckdose 10 aus */
              getchar();
              break;
     case 'm':steckdose(11,1,1);    /* Steckdose 11 ein */
              getchar();
              break; 
     case 'n':steckdose(11,0,1);    /* Steckdose 11 aus */
              getchar();
              break; 
     case 'o':steckdose(12,1,1);    /* Steckdose 12 ein */
              getchar();
              break; 
     case 'p':steckdose(12,0,1);    /* Steckdose 12 aus */
              getchar();
              break;
     case 'q':steckdose(13,1,1);    /* Steckdose 13 ein */
              getchar();
              break; 
     case 'r':steckdose(13,0,1);    /* Steckdose 13 aus */
              getchar();
              break;
     case 's':steckdose(14,1,1);    /* Steckdose 14 ein */
              getchar();
              break; 
     case 't':steckdose(14,0,1);    /* Steckdose 14 aus */
              getchar();
              break;
     case 'u':steckdose(15,1,1);    /* Steckdose 15 ein */
              getchar();
              break; 
     case 'v':steckdose(15,0,1);    /* Steckdose 15 aus */
              getchar();
              break;
     case 'w':steckdose(16,1,1);    /* Steckdose 16 ein */
              getchar();
              break; 
     case 'x':steckdose(16,0,1);    /* Steckdose 16 aus */
              getchar();
              break;
     case 'y':allesaus(); /* Alle 16 Steckdosen der Reihe nach ausschalten. */
              break;                                   
     case '9':endwin();return(0);   /* Prg. Ende */
    } /* von switch */
   } /* von while */
} /* von main */
