/* Programm steckdosen */
/* Schaltet bis zu 16 Steckdosen über den Computer ein und aus. */

/* ACHTUNG! Zum Kompilieren make benutzen. */

/* steckdose, ist das Ansteuerprogramm für die Steckdosen */
/* steckdose.c */

/* SteckdosenNr ist die Nummer der Steckdose, 1 bis 16 */
/* AnAus für die entsprechende Steckdose ein oder aus zu schalten */
/* 1 = Ein  0 = Aus */
/* Zweite_Zeile gibt an ob der Satz "Zum Hauptmenü, eine beliebige Taste drücken." ausgegeben werden soll oder nicht. */
/* 1 = ja, 0 = nein */


#include <sys/io.h>   /* Für den Zugriff auf den Druckerport. */
#include <string.h> /* Für die Funktion strcpy */
#include <unistd.h> /* Für sleep und usleep */
#include "hauptprg.h" /* Enthält die Funktionsdeklarationen. */

#define basisadresse 0x378  /* Basisadresse LPT 1. */
#define Zeitwert 5e5 /* Verzögerungszeit in ms */


void steckdose(int SteckdosenNr, int AnAus, int Zweite_Zeile)
{
  int Sequenz [17][2]; /* Ist das zweidimensionale Feld in dem die Ansteuerseqenzen für die Steckdosen abgelegt werden. */
  char Zustand [50]; /* Bekommt den Zustand "eingeschaltet" oder "ausgeschaltet" im Programmverlauf zugewiesen. */
  
  Sequenz [1][0] = 132;  /* Steckdose 1 aus */
  Sequenz [1][1] = 68;   /* Steckdose 1 ein */
  
  Sequenz [2][0] = 136;  /* Steckdose 2 aus */
  Sequenz [2][1] = 72;   /* Steckdose 2 ein */
  
  Sequenz [3][0] = 144;  /* Steckdose 3 aus */
  Sequenz [3][1] = 80;   /* Steckdose 3 ein */
  
  Sequenz [4][0] = 160;  /* Steckdose 4 aus */
  Sequenz [4][1] = 96;   /* Steckdose 4 ein */
  
  Sequenz [5][0] = 133;  /* Steckdose 5 aus */
  Sequenz [5][1] = 69;   /* Steckdose 5 ein */
  
  Sequenz [6][0] = 137;  /* Steckdose 6 aus */
  Sequenz [6][1] = 73;   /* Steckdose 6 ein */
  
  Sequenz [7][0] = 145;  /* Steckdose 7 aus */
  Sequenz [7][1] = 81;   /* Steckdose 7 ein */
  
  Sequenz [8][0] = 161;  /* Steckdose 8 aus */
  Sequenz [8][1] = 97;   /* Steckdose 8 ein */
  
  Sequenz [9][0] = 134;  /* Steckdose 9 aus */
  Sequenz [9][1] = 70;   /* Steckdose 9 ein */
  
  Sequenz [10][0] = 138; /* Steckdose 10 aus */
  Sequenz [10][1] = 74;  /* Steckdose 10 ein */
  
  Sequenz [11][0] = 146; /* Steckdose 11 aus */
  Sequenz [11][1] = 82;  /* Steckdose 11 ein */
  
  Sequenz [12][0] = 162; /* Steckdose 12 aus */
  Sequenz [12][1] = 98;  /* Steckdose 12 ein */
  
  Sequenz [13][0] = 135; /* Steckdose 13 aus */
  Sequenz [13][1] = 71;  /* Steckdose 13 ein */
  
  Sequenz [14][0] = 139; /* Steckdose 14 aus */
  Sequenz [14][1] = 75;  /* Steckdose 14 ein */
  
  Sequenz [15][0] = 147; /* Steckdose 15 aus */
  Sequenz [15][1] = 83;  /* Steckdose 15 ein */
  
  Sequenz [16][0] = 163; /* Steckdose 16 aus */
  Sequenz [16][1] = 99;  /* Steckdose 16 ein */
  
  
  outb(Sequenz [SteckdosenNr][AnAus],basisadresse); /* Wert rausschreiben */
  if (AnAus == 1) /* wenn AnAus = 1 ist dann */
    {
      strcpy(Zustand,"eingeschaltet"); /* Zustand "eingeschaltet" zuweisen */
      hinweis(SteckdosenNr,&Zustand[0],Zweite_Zeile); /* und ausgeben */
    }  
  else /* Andernfalls */
    {
      strcpy(Zustand,"ausgeschaltet"); /* Zustand "ausgeschaltet" zuweisen */
      hinweis(SteckdosenNr,&Zustand[0],Zweite_Zeile); /* und ausgeben */
    }
  usleep(Zeitwert); /* verzögern */
  outb(0,basisadresse); /* null rausschreiben */
} /* von void */
